using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace NLarge
{
    /// <summary>
    /// Interaction logic for AboutNLarge.xaml
    /// Rob Burke
    /// robburke@microsoft.com
    /// Released under MS-PL (Microsoft permissive license):  http://www.microsoft.com/resources/sharedsource/licensingbasics/permissivelicense.mspx 
    /// Copyright (c) Microsoft Corporation.  All rights reserved.
    /// </summary>
    public partial class AboutNLarge : System.Windows.Window
    {

        private AboutNLarge()
        {
            InitializeComponent();
        }

        private void OnFormLoaded(object sender, RoutedEventArgs e)
        {
        }

        private void OpenBlog(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Process.Start(@"http://blogs.msdn.com/robburke");
        }
        private void ZoomDepthToDefault(object sender, RoutedEventArgs e)
        {
            SliderZoomDepth.Value = 2;
        }
        private void ZoomSpeedToDefault(object sender, RoutedEventArgs e)
        {
            SliderZoomSpeed.Value = 0.8;
        }

        private void CloseAboutWindow(object sender, RoutedEventArgs e)
        {
            Close();
            Instance = null;
        }

        private void OnClosed(object sender, EventArgs e)
        {
        }

        private void UpdateValues(object sender, EventArgs e)
        {
            if (IsLoaded) Window1.ZoomSpeed = this.SliderZoomSpeed.Value;
            if (IsLoaded) Window1.ZoomDepth = this.SliderZoomDepth.Value;
        }

        public static void PresentAboutDialog()
        {
            if (Instance != null)
            {
                Instance.Close();
            }
            Instance = new AboutNLarge();
            Instance.SliderZoomSpeed.Value = Window1.ZoomSpeed;
            Instance.SliderZoomDepth.Value = Window1.ZoomDepth;
            Instance.Show();
        }

        public static void KillAboutDialog()
        {
            if (Instance != null) Instance.Close();
            Instance = null;
        }

        private static AboutNLarge Instance = null;
    }
}